"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var thunkFactory = function (extraArgument) {
    var thunk = (function (store) { return function (next) { return function (reducer) {
        if (typeof reducer !== 'function')
            throw new Error('Thunk reducer must return a function');
        var result = reducer(store.getState());
        if (typeof result === 'function')
            return result(store.dispatch, store.getState, extraArgument);
        else
            return next(function (_) { return result; });
    }; }; });
    thunk.withExtraArgument = thunkFactory;
    return thunk;
};
exports.thunk = thunkFactory();
//# sourceMappingURL=thunk.js.map